

const int ClockPin=3;
const int DataPin=13;
const int StrobePin=2;
const int EnablePin=11;





#define dirPinY 10
#define stepPinY 7

#define dirPinX 8
#define stepPinX 6

#define dirPinZ 8
#define stepPinZ 5

#define numMsInOneSec 1000
#define numMicroSecInOneMs 1000
#define stepPulseWidthInMicroSec 5
#define setupTimeInMicroSec 5
//#define timeBetweenStepsInMicroSec (1 * numMicroSecInOneMs)

//#define inputBufferSize 128

//int  serialCharIn;             
//char serialInString[inputBufferSize];  
//int  serialInIndex  = 0;


int minspeed=5000;
int maxspeed=1000;

char Drive1=0, Drive2=0, Drive3=0;


unsigned long timeBetweenInputPollsInMicroSec = ( (unsigned long)(numMsInOneSec /16) * numMicroSecInOneMs ); // 250 = 1/16th of a second
unsigned long timeBetweenStepsInMicroSecX = maxspeed  ;  //480(1 * numMicroSecInOneMs);
unsigned long timeBetweenStepsInMicroSecY = maxspeed  ;
unsigned long timeBetweenStepsInMicroSecZ = maxspeed  ;

unsigned long loopCheck = 100;

//boolean lineReady = false;
//boolean successfullyParsed = false;
boolean currentDirectionX = false;
boolean currentDirectionY = false;
boolean currentDirectionZ = false;
//boolean shouldStep = true;

//boolean speedChanged = false;  //modificato

void setCurrentDirectionX(boolean dir)
{
  
  if(dir == false)
  {
      digitalWrite(dirPinX, LOW);
  } else {
      digitalWrite(dirPinX, HIGH);
  }
  
  if (currentDirectionX != dir){
     
    /*for( int i=0;i<5;i++){
        flix=average(sample,10); 
        delay(20);    
    } */
  }
  currentDirectionX = dir;
  //delayMicroseconds(setupTimeInMicroSec);
}

void setCurrentDirectionY(boolean dir)
{
  
  if(dir == false)
  {
      digitalWrite(dirPinY, LOW);
  } else {
      digitalWrite(dirPinY, HIGH);
  }
  
  if (currentDirectionY != dir){
    //delay(100);
    /*for( int i=0;i<5;i++){
      fliy=average(sample,11);    
      delay(20); 
    }*/
  }
  currentDirectionY = dir;
  //delayMicroseconds(setupTimeInMicroSec);
}

void setCurrentDirectionZ(boolean dir)
{
  
  if(dir == false)
  {
      digitalWrite(dirPinZ, LOW);
  } else {
      digitalWrite(dirPinZ, HIGH);
  }
  
  if (currentDirectionZ != dir){
    //delay(100);
    /*for( int i=0;i<5;i++){
      fliy=average(sample,11);    
      delay(20); 
    }*/
  }
  currentDirectionZ = dir;
  //delayMicroseconds(setupTimeInMicroSec);
}

void enableStepperX(int isEnabled)
{
  if(isEnabled)
  {
      Drive1=Drive1 & B01111111;
      //digitalWrite(enablePinX, LOW); // enable HIGH = stepper driver OFF
  } else {
      //digitalWrite(enablePinX, HIGH); // enable HIGH = stepper driver OFF
      Drive1=Drive1 | B10000000;
  }
  // wait a few microseconds for the enable to take effect 
  // (That isn't in the spec sheet I just added it for sanity.) 
  SetDrive();
  //delayMicroseconds(2);
}

void enableStepperY(int isEnabled)
{
  if(isEnabled)
  {
      Drive2=Drive2 & B01111111;
      //digitalWrite(enablePinY, LOW); // enable HIGH = stepper driver OFF
  } else {
      //digitalWrite(enablePinY, HIGH); // enable HIGH = stepper driver OFF
      Drive2=Drive2 | B10000000;
  }
  // wait a few microseconds for the enable to take effect 
  // (That isn't in the spec sheet I just added it for sanity.) 
  SetDrive();
  //delayMicroseconds(2);
}

void enableStepperZ(int isEnabled)
{
  if(isEnabled)
  {
      Drive3=Drive3 & B01111111;
      //digitalWrite(enablePinY, LOW); // enable HIGH = stepper driver OFF
  } else {
      //digitalWrite(enablePinY, HIGH); // enable HIGH = stepper driver OFF
      Drive3=Drive3 | B10000000;
  }
  // wait a few microseconds for the enable to take effect 
  // (That isn't in the spec sheet I just added it for sanity.) 
  SetDrive();
  //delayMicroseconds(2);
}

void takeSingleStepX()
{
    digitalWrite(stepPinX, LOW);
    delayMicroseconds(stepPulseWidthInMicroSec); 
    digitalWrite(stepPinX, HIGH); 
    delayMicroseconds(stepPulseWidthInMicroSec); 
    digitalWrite(stepPinX, LOW);
}

void takeSingleStepY()
{
    digitalWrite(stepPinY, LOW);
    delayMicroseconds(stepPulseWidthInMicroSec); 
    digitalWrite(stepPinY, HIGH); 
    delayMicroseconds(stepPulseWidthInMicroSec); 
    digitalWrite(stepPinY, LOW);
}

void takeSingleStepZ()
{
    digitalWrite(stepPinZ, LOW);
    delayMicroseconds(stepPulseWidthInMicroSec); 
    digitalWrite(stepPinZ, HIGH); 
    delayMicroseconds(stepPulseWidthInMicroSec); 
    digitalWrite(stepPinZ, LOW);
}


void setFullStep()
{
  Drive1=Drive1 & B10110011;
  Drive2=Drive2 & B10110011;
  Drive3=Drive3 & B10110011;
  /*digitalWrite(MicroStep1PinX, LOW);
  digitalWrite(MicroStep2PinX, LOW);
  digitalWrite(MicroStep3PinX, LOW);
  
  digitalWrite(MicroStep1PinY, LOW);
  digitalWrite(MicroStep2PinY, LOW);
  digitalWrite(MicroStep3PinY, LOW);
  */
  SetDrive();
  delayMicroseconds(setupTimeInMicroSec);
}

void setHalfStep()
{
  Drive1=Drive1 & B10110011;
  Drive2=Drive2 & B10110011;
  Drive3=Drive3 & B10110011;
  
  Drive1=Drive1 | B01000000;
  Drive2=Drive2 | B01000000;
  Drive3=Drive3 | B01000000;
  /*digitalWrite(MicroStep1PinX, HIGH);
  digitalWrite(MicroStep2PinX, LOW);
  digitalWrite(MicroStep3PinX, LOW);
  
  digitalWrite(MicroStep1PinY, HIGH);
  digitalWrite(MicroStep2PinY, LOW);
  digitalWrite(MicroStep3PinY, LOW);
  */
  SetDrive();
  delayMicroseconds(setupTimeInMicroSec);
}

void setQuarterStep()
{
  Drive1=Drive1 & B10110011;
  Drive2=Drive2 & B10110011;
  Drive3=Drive3 & B10110011;
  
  Drive1=Drive1 | B00001000;
  Drive2=Drive2 | B00001000;
  Drive3=Drive3 | B00001000;
  /*
  digitalWrite(MicroStep1PinX, LOW);
  digitalWrite(MicroStep2PinX, HIGH);
  digitalWrite(MicroStep3PinX, LOW);
  
  digitalWrite(MicroStep1PinY, LOW);
  digitalWrite(MicroStep2PinY, HIGH);
  digitalWrite(MicroStep3PinY, LOW);
  */
  SetDrive();
  delayMicroseconds(setupTimeInMicroSec);  
}

void setEighthStep()
{
  Drive1=Drive1 & B10110011;
  Drive2=Drive2 & B10110011;
  Drive3=Drive3 & B10110011;
  
  Drive1=Drive1 | B01001000;
  Drive2=Drive2 | B01001000;
  Drive3=Drive3 | B01001000;
  
  /*digitalWrite(MicroStep1PinX, HIGH);
  digitalWrite(MicroStep2PinX, HIGH);
  digitalWrite(MicroStep3PinX, LOW);
  
  digitalWrite(MicroStep1PinY, HIGH);
  digitalWrite(MicroStep2PinY, HIGH);
  digitalWrite(MicroStep3PinY, LOW);*/
  SetDrive();
  delayMicroseconds(setupTimeInMicroSec);  
}

void setSixteenthStep()
{
  Drive1=Drive1 & B10110011;
  Drive2=Drive2 & B10110011;
  Drive3=Drive3 & B10110011;
  
  Drive1=Drive1 | B01001100;
  Drive2=Drive2 | B01001100;
  Drive3=Drive3 | B01001100;
  
  /*
  digitalWrite(MicroStep1PinX, HIGH);
  digitalWrite(MicroStep2PinX, HIGH);
  digitalWrite(MicroStep3PinX, HIGH);
  
  digitalWrite(MicroStep1PinY, HIGH);
  digitalWrite(MicroStep2PinY, HIGH);
  digitalWrite(MicroStep3PinY, HIGH);
  */
  SetDrive();
  delayMicroseconds(setupTimeInMicroSec);  
}


void setup() 
{

  // We set the enable pin to be an output 
  //pinMode(enablePinX, OUTPUT); // then we set it HIGH so that the board is disabled until we 
  pinMode(stepPinX, OUTPUT); 
  pinMode(dirPinX, OUTPUT);
  pinMode(stepPinY, OUTPUT); 
  pinMode(dirPinY, OUTPUT);
  pinMode(stepPinZ, OUTPUT); 
  pinMode(dirPinZ, OUTPUT);
 // pinMode(resetPinX, OUTPUT);
 // pinMode(sleepPinX, OUTPUT);
  
  //pinMode(MicroStep1PinX, OUTPUT);
  //pinMode(MicroStep2PinX, OUTPUT);
  //pinMode(MicroStep3PinX, OUTPUT);
  
  pinMode(ClockPin, OUTPUT); 
  pinMode(DataPin, OUTPUT); 
  pinMode(StrobePin, OUTPUT);
  pinMode(EnablePin, OUTPUT);
  
  digitalWrite(EnablePin,HIGH);
  
  //digitalWrite(resetPinX, HIGH);  
  //digitalWrite(sleepPinX, HIGH);
  
  //pinMode(enablePinY, OUTPUT); // then we set it HIGH so that the board is disabled until we 

  //pinMode(resetPinY, OUTPUT);
  //pinMode(sleepPinY, OUTPUT);
  
  //pinMode(MicroStep1PinY, OUTPUT);
  //pinMode(MicroStep2PinY, OUTPUT);
  //pinMode(MicroStep3PinY, OUTPUT);
  
  //digitalWrite(resetPinY, HIGH);  
  //digitalWrite(sleepPinY, HIGH);
  
  Drive1=Drive1 | B00000011;
  Drive2=Drive2 | B00000011;
  Drive3=Drive3 | B00000011;
  
  SetDrive();
    // get into a known state. 
  enableStepperX(false);
  enableStepperY(false);
  enableStepperZ(false);
  // we set the direction pin in an arbitrary direction.
  setCurrentDirectionX(false);
  setCurrentDirectionY(false);
  setCurrentDirectionZ(false);
  setFullStep();
  //setQuarterStep();
  //setEighthStep();
  //setSixteenthStep();
  Serial.begin(9600); 
  Serial.println("Starting stepper dev tester.");
  
  enableStepperX(true);
  enableStepperY(true);
  enableStepperZ(true);
 // we set the direction pin in an arbitrary direction. 
  setCurrentDirectionX(true);
  setCurrentDirectionY(true);
  setCurrentDirectionZ(true);
}

void loop() 
{ 
  int j; 
 
      motorX();

      motorY();
      
      motorZ();

  
}



void motorX(){
  
//    for(int j=0; j<loopCheck; j++) 
//    { 
      takeSingleStepX();
      delayMicroseconds(timeBetweenStepsInMicroSecX);
//    } 
    
  }
  
void motorY(){
  
//    for(int j=0; j<loopCheck; j++) 
//    { 
      takeSingleStepY();
      delayMicroseconds(timeBetweenStepsInMicroSecY);
//    } 
    
  }  
  
void motorZ(){
  
//    for(int j=0; j<loopCheck; j++) 
//    { 
      takeSingleStepZ();
      delayMicroseconds(timeBetweenStepsInMicroSecZ);
//    } 
    
  }  


void SetDrive(void) {
 // Vengono illuminati i led
 shiftOut(DataPin, ClockPin, MSBFIRST, Drive1);
 shiftOut(DataPin, ClockPin, MSBFIRST, Drive2);
 shiftOut(DataPin, ClockPin, MSBFIRST, Drive3);
 digitalWrite(StrobePin,HIGH);
 delay(2);
 digitalWrite(StrobePin,LOW);    

 }
 
 

